cli.zsh 22 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804
  1. #!/usr/bin/env zsh
  2. function omz {
  3. [[ $# -gt 0 ]] || {
  4. _omz::help
  5. return 1
  6. }
  7. local command="$1"
  8. shift
  9. # Subcommand functions start with _ so that they don't
  10. # appear as completion entries when looking for `omz`
  11. (( $+functions[_omz::$command] )) || {
  12. _omz::help
  13. return 1
  14. }
  15. _omz::$command "$@"
  16. }
  17. function _omz {
  18. local -a cmds subcmds
  19. cmds=(
  20. 'changelog:Print the changelog'
  21. 'help:Usage information'
  22. 'plugin:Manage plugins'
  23. 'pr:Manage Oh My Zsh Pull Requests'
  24. 'reload:Reload the current zsh session'
  25. 'theme:Manage themes'
  26. 'update:Update Oh My Zsh'
  27. 'version:Show the version'
  28. )
  29. if (( CURRENT == 2 )); then
  30. _describe 'command' cmds
  31. elif (( CURRENT == 3 )); then
  32. case "$words[2]" in
  33. changelog) local -a refs
  34. refs=("${(@f)$(cd "$ZSH"; command git for-each-ref --format="%(refname:short):%(subject)" refs/heads refs/tags)}")
  35. _describe 'command' refs ;;
  36. plugin) subcmds=(
  37. 'disable:Disable plugin(s)'
  38. 'enable:Enable plugin(s)'
  39. 'info:Get plugin information'
  40. 'list:List plugins'
  41. 'load:Load plugin(s)'
  42. )
  43. _describe 'command' subcmds ;;
  44. pr) subcmds=('clean:Delete all Pull Request branches' 'test:Test a Pull Request')
  45. _describe 'command' subcmds ;;
  46. theme) subcmds=('list:List themes' 'set:Set a theme in your .zshrc file' 'use:Load a theme')
  47. _describe 'command' subcmds ;;
  48. esac
  49. elif (( CURRENT == 4 )); then
  50. case "${words[2]}::${words[3]}" in
  51. plugin::(disable|enable|load))
  52. local -aU valid_plugins
  53. if [[ "${words[3]}" = disable ]]; then
  54. # if command is "disable", only offer already enabled plugins
  55. valid_plugins=($plugins)
  56. else
  57. valid_plugins=("$ZSH"/plugins/*/{_*,*.plugin.zsh}(.N:h:t) "$ZSH_CUSTOM"/plugins/*/{_*,*.plugin.zsh}(.N:h:t))
  58. # if command is "enable", remove already enabled plugins
  59. [[ "${words[3]}" = enable ]] && valid_plugins=(${valid_plugins:|plugins})
  60. fi
  61. _describe 'plugin' valid_plugins ;;
  62. plugin::info)
  63. local -aU plugins
  64. plugins=("$ZSH"/plugins/*/{_*,*.plugin.zsh}(.N:h:t) "$ZSH_CUSTOM"/plugins/*/{_*,*.plugin.zsh}(.N:h:t))
  65. _describe 'plugin' plugins ;;
  66. theme::(set|use))
  67. local -aU themes
  68. themes=("$ZSH"/themes/*.zsh-theme(.N:t:r) "$ZSH_CUSTOM"/**/*.zsh-theme(.N:r:gs:"$ZSH_CUSTOM"/themes/:::gs:"$ZSH_CUSTOM"/:::))
  69. _describe 'theme' themes ;;
  70. esac
  71. elif (( CURRENT > 4 )); then
  72. case "${words[2]}::${words[3]}" in
  73. plugin::(enable|disable|load))
  74. local -aU valid_plugins
  75. if [[ "${words[3]}" = disable ]]; then
  76. # if command is "disable", only offer already enabled plugins
  77. valid_plugins=($plugins)
  78. else
  79. valid_plugins=("$ZSH"/plugins/*/{_*,*.plugin.zsh}(.N:h:t) "$ZSH_CUSTOM"/plugins/*/{_*,*.plugin.zsh}(.N:h:t))
  80. # if command is "enable", remove already enabled plugins
  81. [[ "${words[3]}" = enable ]] && valid_plugins=(${valid_plugins:|plugins})
  82. fi
  83. # Remove plugins already passed as arguments
  84. # NOTE: $(( CURRENT - 1 )) is the last plugin argument completely passed, i.e. that which
  85. # has a space after them. This is to avoid removing plugins partially passed, which makes
  86. # the completion not add a space after the completed plugin.
  87. local -a args
  88. args=(${words[4,$(( CURRENT - 1))]})
  89. valid_plugins=(${valid_plugins:|args})
  90. _describe 'plugin' valid_plugins ;;
  91. esac
  92. fi
  93. return 0
  94. }
  95. compdef _omz omz
  96. ## Utility functions
  97. function _omz::confirm {
  98. # If question supplied, ask it before reading the answer
  99. # NOTE: uses the logname of the caller function
  100. if [[ -n "$1" ]]; then
  101. _omz::log prompt "$1" "${${functrace[1]#_}%:*}"
  102. fi
  103. # Read one character
  104. read -r -k 1
  105. # If no newline entered, add a newline
  106. if [[ "$REPLY" != $'\n' ]]; then
  107. echo
  108. fi
  109. }
  110. function _omz::log {
  111. # if promptsubst is set, a message with `` or $()
  112. # will be run even if quoted due to `print -P`
  113. setopt localoptions nopromptsubst
  114. # $1 = info|warn|error|debug
  115. # $2 = text
  116. # $3 = (optional) name of the logger
  117. local logtype=$1
  118. local logname=${3:-${${functrace[1]#_}%:*}}
  119. # Don't print anything if debug is not active
  120. if [[ $logtype = debug && -z $_OMZ_DEBUG ]]; then
  121. return
  122. fi
  123. # Choose coloring based on log type
  124. case "$logtype" in
  125. prompt) print -Pn "%S%F{blue}$logname%f%s: $2" ;;
  126. debug) print -P "%F{white}$logname%f: $2" ;;
  127. info) print -P "%F{green}$logname%f: $2" ;;
  128. warn) print -P "%S%F{yellow}$logname%f%s: $2" ;;
  129. error) print -P "%S%F{red}$logname%f%s: $2" ;;
  130. esac >&2
  131. }
  132. ## User-facing commands
  133. function _omz::help {
  134. cat >&2 <<EOF
  135. Usage: omz <command> [options]
  136. Available commands:
  137. help Print this help message
  138. changelog Print the changelog
  139. plugin <command> Manage plugins
  140. pr <command> Manage Oh My Zsh Pull Requests
  141. reload Reload the current zsh session
  142. theme <command> Manage themes
  143. update Update Oh My Zsh
  144. version Show the version
  145. EOF
  146. }
  147. function _omz::changelog {
  148. local version=${1:-HEAD} format=${3:-"--text"}
  149. if (
  150. cd "$ZSH"
  151. ! command git show-ref --verify refs/heads/$version && \
  152. ! command git show-ref --verify refs/tags/$version && \
  153. ! command git rev-parse --verify "${version}^{commit}"
  154. ) &>/dev/null; then
  155. cat >&2 <<EOF
  156. Usage: omz changelog [version]
  157. NOTE: <version> must be a valid branch, tag or commit.
  158. EOF
  159. return 1
  160. fi
  161. "$ZSH/tools/changelog.sh" "$version" "${2:-}" "$format"
  162. }
  163. function _omz::plugin {
  164. (( $# > 0 && $+functions[_omz::plugin::$1] )) || {
  165. cat >&2 <<EOF
  166. Usage: omz plugin <command> [options]
  167. Available commands:
  168. disable <plugin> Disable plugin(s)
  169. enable <plugin> Enable plugin(s)
  170. info <plugin> Get information of a plugin
  171. list List all available Oh My Zsh plugins
  172. load <plugin> Load plugin(s)
  173. EOF
  174. return 1
  175. }
  176. local command="$1"
  177. shift
  178. _omz::plugin::$command "$@"
  179. }
  180. function _omz::plugin::disable {
  181. if [[ -z "$1" ]]; then
  182. echo >&2 "Usage: omz plugin disable <plugin> [...]"
  183. return 1
  184. fi
  185. # Check that plugin is in $plugins
  186. local -a dis_plugins
  187. for plugin in "$@"; do
  188. if [[ ${plugins[(Ie)$plugin]} -eq 0 ]]; then
  189. _omz::log warn "plugin '$plugin' is not enabled."
  190. continue
  191. fi
  192. dis_plugins+=("$plugin")
  193. done
  194. # Exit if there are no enabled plugins to disable
  195. if [[ ${#dis_plugins} -eq 0 ]]; then
  196. return 1
  197. fi
  198. # Remove plugins substitution awk script
  199. local awk_subst_plugins="\
  200. gsub(/\s+(${(j:|:)dis_plugins})/, \"\") # with spaces before
  201. gsub(/(${(j:|:)dis_plugins})\s+/, \"\") # with spaces after
  202. gsub(/\((${(j:|:)dis_plugins})\)/, \"\") # without spaces (only plugin)
  203. "
  204. # Disable plugins awk script
  205. local awk_script="
  206. # if plugins=() is in oneline form, substitute disabled plugins and go to next line
  207. /^\s*plugins=\([^#]+\).*\$/ {
  208. $awk_subst_plugins
  209. print \$0
  210. next
  211. }
  212. # if plugins=() is in multiline form, enable multi flag and disable plugins if they're there
  213. /^\s*plugins=\(/ {
  214. multi=1
  215. $awk_subst_plugins
  216. print \$0
  217. next
  218. }
  219. # if multi flag is enabled and we find a valid closing parenthesis, remove plugins and disable multi flag
  220. multi == 1 && /^[^#]*\)/ {
  221. multi=0
  222. $awk_subst_plugins
  223. print \$0
  224. next
  225. }
  226. multi == 1 && length(\$0) > 0 {
  227. $awk_subst_plugins
  228. if (length(\$0) > 0) print \$0
  229. next
  230. }
  231. { print \$0 }
  232. "
  233. awk "$awk_script" ~/.zshrc > ~/.zshrc.new \
  234. && command mv -f ~/.zshrc ~/.zshrc.bck \
  235. && command mv -f ~/.zshrc.new ~/.zshrc
  236. # Exit if the new .zshrc file wasn't created correctly
  237. [[ $? -eq 0 ]] || {
  238. local ret=$?
  239. _omz::log error "error disabling plugins."
  240. return $ret
  241. }
  242. # Exit if the new .zshrc file has syntax errors
  243. if ! zsh -n ~/.zshrc; then
  244. _omz::log error "broken syntax in ~/.zshrc. Rolling back changes..."
  245. command mv -f ~/.zshrc ~/.zshrc.new
  246. command mv -f ~/.zshrc.bck ~/.zshrc
  247. return 1
  248. fi
  249. # Restart the zsh session if there were no errors
  250. _omz::log info "plugins disabled: ${(j:, :)dis_plugins}."
  251. # Old zsh versions don't have ZSH_ARGZERO
  252. local zsh="${ZSH_ARGZERO:-${functrace[-1]%:*}}"
  253. # Check whether to run a login shell
  254. [[ "$zsh" = -* || -o login ]] && exec -l "${zsh#-}" || exec "$zsh"
  255. }
  256. function _omz::plugin::enable {
  257. if [[ -z "$1" ]]; then
  258. echo >&2 "Usage: omz plugin enable <plugin> [...]"
  259. return 1
  260. fi
  261. # Check that plugin is not in $plugins
  262. local -a add_plugins
  263. for plugin in "$@"; do
  264. if [[ ${plugins[(Ie)$plugin]} -ne 0 ]]; then
  265. _omz::log warn "plugin '$plugin' is already enabled."
  266. continue
  267. fi
  268. add_plugins+=("$plugin")
  269. done
  270. # Exit if there are no plugins to enable
  271. if [[ ${#add_plugins} -eq 0 ]]; then
  272. return 1
  273. fi
  274. # Enable plugins awk script
  275. local awk_script="
  276. # if plugins=() is in oneline form, substitute ) with new plugins and go to the next line
  277. /^\s*plugins=\([^#]+\).*\$/ {
  278. sub(/\)/, \" $add_plugins&\")
  279. print \$0
  280. next
  281. }
  282. # if plugins=() is in multiline form, enable multi flag
  283. /^\s*plugins=\(/ {
  284. multi=1
  285. }
  286. # if multi flag is enabled and we find a valid closing parenthesis,
  287. # add new plugins and disable multi flag
  288. multi == 1 && /^[^#]*\)/ {
  289. multi=0
  290. sub(/\)/, \" $add_plugins&\")
  291. print \$0
  292. next
  293. }
  294. { print \$0 }
  295. "
  296. awk "$awk_script" ~/.zshrc > ~/.zshrc.new \
  297. && command mv -f ~/.zshrc ~/.zshrc.bck \
  298. && command mv -f ~/.zshrc.new ~/.zshrc
  299. # Exit if the new .zshrc file wasn't created correctly
  300. [[ $? -eq 0 ]] || {
  301. local ret=$?
  302. _omz::log error "error enabling plugins."
  303. return $ret
  304. }
  305. # Exit if the new .zshrc file has syntax errors
  306. if ! zsh -n ~/.zshrc; then
  307. _omz::log error "broken syntax in ~/.zshrc. Rolling back changes..."
  308. command mv -f ~/.zshrc ~/.zshrc.new
  309. command mv -f ~/.zshrc.bck ~/.zshrc
  310. return 1
  311. fi
  312. # Restart the zsh session if there were no errors
  313. _omz::log info "plugins enabled: ${(j:, :)add_plugins}."
  314. # Old zsh versions don't have ZSH_ARGZERO
  315. local zsh="${ZSH_ARGZERO:-${functrace[-1]%:*}}"
  316. # Check whether to run a login shell
  317. [[ "$zsh" = -* || -o login ]] && exec -l "${zsh#-}" || exec "$zsh"
  318. }
  319. function _omz::plugin::info {
  320. if [[ -z "$1" ]]; then
  321. echo >&2 "Usage: omz plugin info <plugin>"
  322. return 1
  323. fi
  324. local readme
  325. for readme in "$ZSH_CUSTOM/plugins/$1/README.md" "$ZSH/plugins/$1/README.md"; do
  326. if [[ -f "$readme" ]]; then
  327. (( ${+commands[less]} )) && less "$readme" || cat "$readme"
  328. return 0
  329. fi
  330. done
  331. if [[ -d "$ZSH_CUSTOM/plugins/$1" || -d "$ZSH/plugins/$1" ]]; then
  332. _omz::log error "the '$1' plugin doesn't have a README file"
  333. else
  334. _omz::log error "'$1' plugin not found"
  335. fi
  336. return 1
  337. }
  338. function _omz::plugin::list {
  339. local -a custom_plugins builtin_plugins
  340. custom_plugins=("$ZSH_CUSTOM"/plugins/*(-/N:t))
  341. builtin_plugins=("$ZSH"/plugins/*(-/N:t))
  342. # If the command is being piped, print all found line by line
  343. if [[ ! -t 1 ]]; then
  344. print -l ${(q-)custom_plugins} ${(q-)builtin_plugins}
  345. return
  346. fi
  347. if (( ${#custom_plugins} )); then
  348. print -P "%U%BCustom plugins%b%u:"
  349. print -l ${(q-)custom_plugins} | column -x
  350. fi
  351. if (( ${#builtin_plugins} )); then
  352. (( ${#custom_plugins} )) && echo # add a line of separation
  353. print -P "%U%BBuilt-in plugins%b%u:"
  354. print -l ${(q-)builtin_plugins} | column -x
  355. fi
  356. }
  357. function _omz::plugin::load {
  358. if [[ -z "$1" ]]; then
  359. echo >&2 "Usage: omz plugin load <plugin> [...]"
  360. return 1
  361. fi
  362. local plugin base has_completion=0
  363. for plugin in "$@"; do
  364. if [[ -d "$ZSH_CUSTOM/plugins/$plugin" ]]; then
  365. base="$ZSH_CUSTOM/plugins/$plugin"
  366. elif [[ -d "$ZSH/plugins/$plugin" ]]; then
  367. base="$ZSH/plugins/$plugin"
  368. else
  369. _omz::log warn "plugin '$plugin' not found"
  370. continue
  371. fi
  372. # Check if its a valid plugin
  373. if [[ ! -f "$base/_$plugin" && ! -f "$base/$plugin.plugin.zsh" ]]; then
  374. _omz::log warn "'$plugin' is not a valid plugin"
  375. continue
  376. # It it is a valid plugin, add its directory to $fpath unless it is already there
  377. elif (( ! ${fpath[(Ie)$base]} )); then
  378. fpath=("$base" $fpath)
  379. fi
  380. # Check if it has completion to reload compinit
  381. local -a comp_files
  382. comp_files=($base/_*(N))
  383. has_completion=$(( $#comp_files > 0 ))
  384. # Load the plugin
  385. if [[ -f "$base/$plugin.plugin.zsh" ]]; then
  386. source "$base/$plugin.plugin.zsh"
  387. fi
  388. done
  389. # If we have completion, we need to reload the completion
  390. # We pass -D to avoid generating a new dump file, which would overwrite our
  391. # current one for the next session (and we don't want that because we're not
  392. # actually enabling the plugins for the next session).
  393. # Note that we still have to pass -d "$_comp_dumpfile", so that compinit
  394. # doesn't use the default zcompdump location (${ZDOTDIR:-$HOME}/.zcompdump).
  395. if (( has_completion )); then
  396. compinit -D -d "$_comp_dumpfile"
  397. fi
  398. }
  399. function _omz::pr {
  400. (( $# > 0 && $+functions[_omz::pr::$1] )) || {
  401. cat >&2 <<EOF
  402. Usage: omz pr <command> [options]
  403. Available commands:
  404. clean Delete all PR branches (ohmyzsh/pull-*)
  405. test <PR_number_or_URL> Fetch PR #NUMBER and rebase against master
  406. EOF
  407. return 1
  408. }
  409. local command="$1"
  410. shift
  411. _omz::pr::$command "$@"
  412. }
  413. function _omz::pr::clean {
  414. (
  415. set -e
  416. builtin cd -q "$ZSH"
  417. # Check if there are PR branches
  418. local fmt branches
  419. fmt="%(color:bold blue)%(align:18,right)%(refname:short)%(end)%(color:reset) %(color:dim bold red)%(objectname:short)%(color:reset) %(color:yellow)%(contents:subject)"
  420. branches="$(command git for-each-ref --sort=-committerdate --color --format="$fmt" "refs/heads/ohmyzsh/pull-*")"
  421. # Exit if there are no PR branches
  422. if [[ -z "$branches" ]]; then
  423. _omz::log info "there are no Pull Request branches to remove."
  424. return
  425. fi
  426. # Print found PR branches
  427. echo "$branches\n"
  428. # Confirm before removing the branches
  429. _omz::confirm "do you want remove these Pull Request branches? [Y/n] "
  430. # Only proceed if the answer is a valid yes option
  431. [[ "$REPLY" != [yY$'\n'] ]] && return
  432. _omz::log info "removing all Oh My Zsh Pull Request branches..."
  433. command git branch --list 'ohmyzsh/pull-*' | while read branch; do
  434. command git branch -D "$branch"
  435. done
  436. )
  437. }
  438. function _omz::pr::test {
  439. # Allow $1 to be a URL to the pull request
  440. if [[ "$1" = https://* ]]; then
  441. 1="${1:t}"
  442. fi
  443. # Check the input
  444. if ! [[ -n "$1" && "$1" =~ ^[[:digit:]]+$ ]]; then
  445. echo >&2 "Usage: omz pr test <PR_NUMBER_or_URL>"
  446. return 1
  447. fi
  448. # Save current git HEAD
  449. local branch
  450. branch=$(builtin cd -q "$ZSH"; git symbolic-ref --short HEAD) || {
  451. _omz::log error "error when getting the current git branch. Aborting..."
  452. return 1
  453. }
  454. # Fetch PR onto ohmyzsh/pull-<PR_NUMBER> branch and rebase against master
  455. # If any of these operations fail, undo the changes made
  456. (
  457. set -e
  458. builtin cd -q "$ZSH"
  459. # Get the ohmyzsh git remote
  460. command git remote -v | while read remote url _; do
  461. case "$url" in
  462. https://github.com/ohmyzsh/ohmyzsh(|.git)) found=1; break ;;
  463. git@github.com:ohmyzsh/ohmyzsh(|.git)) found=1; break ;;
  464. esac
  465. done
  466. (( $found )) || {
  467. _omz::log error "could not found the ohmyzsh git remote. Aborting..."
  468. return 1
  469. }
  470. # Fetch pull request head
  471. _omz::log info "fetching PR #$1 to ohmyzsh/pull-$1..."
  472. command git fetch -f "$remote" refs/pull/$1/head:ohmyzsh/pull-$1 || {
  473. _omz::log error "error when trying to fetch PR #$1."
  474. return 1
  475. }
  476. # Rebase pull request branch against the current master
  477. _omz::log info "rebasing PR #$1..."
  478. command git rebase master ohmyzsh/pull-$1 || {
  479. command git rebase --abort &>/dev/null
  480. _omz::log warn "could not rebase PR #$1 on top of master."
  481. _omz::log warn "you might not see the latest stable changes."
  482. _omz::log info "run \`zsh\` to test the changes."
  483. return 1
  484. }
  485. _omz::log info "fetch of PR #${1} successful."
  486. )
  487. # If there was an error, abort running zsh to test the PR
  488. [[ $? -eq 0 ]] || return 1
  489. # Run zsh to test the changes
  490. _omz::log info "running \`zsh\` to test the changes. Run \`exit\` to go back."
  491. command zsh -l
  492. # After testing, go back to the previous HEAD if the user wants
  493. _omz::confirm "do you want to go back to the previous branch? [Y/n] "
  494. # Only proceed if the answer is a valid yes option
  495. [[ "$REPLY" != [yY$'\n'] ]] && return
  496. (
  497. set -e
  498. builtin cd -q "$ZSH"
  499. command git checkout "$branch" -- || {
  500. _omz::log error "could not go back to the previous branch ('$branch')."
  501. return 1
  502. }
  503. )
  504. }
  505. function _omz::reload {
  506. # Delete current completion cache
  507. command rm -f $_comp_dumpfile $ZSH_COMPDUMP
  508. # Old zsh versions don't have ZSH_ARGZERO
  509. local zsh="${ZSH_ARGZERO:-${functrace[-1]%:*}}"
  510. # Check whether to run a login shell
  511. [[ "$zsh" = -* || -o login ]] && exec -l "${zsh#-}" || exec "$zsh"
  512. }
  513. function _omz::theme {
  514. (( $# > 0 && $+functions[_omz::theme::$1] )) || {
  515. cat >&2 <<EOF
  516. Usage: omz theme <command> [options]
  517. Available commands:
  518. list List all available Oh My Zsh themes
  519. set <theme> Set a theme in your .zshrc file
  520. use <theme> Load a theme
  521. EOF
  522. return 1
  523. }
  524. local command="$1"
  525. shift
  526. _omz::theme::$command "$@"
  527. }
  528. function _omz::theme::list {
  529. local -a custom_themes builtin_themes
  530. custom_themes=("$ZSH_CUSTOM"/**/*.zsh-theme(-.N:r:gs:"$ZSH_CUSTOM"/themes/:::gs:"$ZSH_CUSTOM"/:::))
  531. builtin_themes=("$ZSH"/themes/*.zsh-theme(-.N:t:r))
  532. # If the command is being piped, print all found line by line
  533. if [[ ! -t 1 ]]; then
  534. print -l ${(q-)custom_themes} ${(q-)builtin_themes}
  535. return
  536. fi
  537. # Print theme in use
  538. if [[ -n "$ZSH_THEME" ]]; then
  539. print -Pn "%U%BCurrent theme%b%u: "
  540. [[ $ZSH_THEME = random ]] && echo "$RANDOM_THEME (via random)" || echo "$ZSH_THEME"
  541. echo
  542. fi
  543. # Print custom themes if there are any
  544. if (( ${#custom_themes} )); then
  545. print -P "%U%BCustom themes%b%u:"
  546. print -l ${(q-)custom_themes} | column -x
  547. echo
  548. fi
  549. # Print built-in themes
  550. print -P "%U%BBuilt-in themes%b%u:"
  551. print -l ${(q-)builtin_themes} | column -x
  552. }
  553. function _omz::theme::set {
  554. if [[ -z "$1" ]]; then
  555. echo >&2 "Usage: omz theme set <theme>"
  556. return 1
  557. fi
  558. # Check that theme exists
  559. if [[ ! -f "$ZSH_CUSTOM/$1.zsh-theme" ]] \
  560. && [[ ! -f "$ZSH_CUSTOM/themes/$1.zsh-theme" ]] \
  561. && [[ ! -f "$ZSH/themes/$1.zsh-theme" ]]; then
  562. _omz::log error "%B$1%b theme not found"
  563. return 1
  564. fi
  565. # Enable theme in .zshrc
  566. local awk_script='
  567. !set && /^\s*ZSH_THEME=[^#]+.*$/ {
  568. set=1
  569. sub(/^\s*ZSH_THEME=[^#]+.*$/, "ZSH_THEME=\"'$1'\" # set by `omz`")
  570. print $0
  571. next
  572. }
  573. { print $0 }
  574. END {
  575. # If no ZSH_THEME= line was found, return an error
  576. if (!set) exit 1
  577. }
  578. '
  579. awk "$awk_script" ~/.zshrc > ~/.zshrc.new \
  580. || {
  581. # Prepend ZSH_THEME= line to .zshrc if it doesn't exist
  582. cat <<EOF
  583. ZSH_THEME="$1" # set by \`omz\`
  584. EOF
  585. cat ~/.zshrc
  586. } > ~/.zshrc.new \
  587. && command mv -f ~/.zshrc ~/.zshrc.bck \
  588. && command mv -f ~/.zshrc.new ~/.zshrc
  589. # Exit if the new .zshrc file wasn't created correctly
  590. [[ $? -eq 0 ]] || {
  591. local ret=$?
  592. _omz::log error "error setting theme."
  593. return $ret
  594. }
  595. # Exit if the new .zshrc file has syntax errors
  596. if ! zsh -n ~/.zshrc; then
  597. _omz::log error "broken syntax in ~/.zshrc. Rolling back changes..."
  598. command mv -f ~/.zshrc ~/.zshrc.new
  599. command mv -f ~/.zshrc.bck ~/.zshrc
  600. return 1
  601. fi
  602. # Restart the zsh session if there were no errors
  603. _omz::log info "'$1' theme set correctly."
  604. # Old zsh versions don't have ZSH_ARGZERO
  605. local zsh="${ZSH_ARGZERO:-${functrace[-1]%:*}}"
  606. # Check whether to run a login shell
  607. [[ "$zsh" = -* || -o login ]] && exec -l "${zsh#-}" || exec "$zsh"
  608. }
  609. function _omz::theme::use {
  610. if [[ -z "$1" ]]; then
  611. echo >&2 "Usage: omz theme use <theme>"
  612. return 1
  613. fi
  614. # Respect compatibility with old lookup order
  615. if [[ -f "$ZSH_CUSTOM/$1.zsh-theme" ]]; then
  616. source "$ZSH_CUSTOM/$1.zsh-theme"
  617. elif [[ -f "$ZSH_CUSTOM/themes/$1.zsh-theme" ]]; then
  618. source "$ZSH_CUSTOM/themes/$1.zsh-theme"
  619. elif [[ -f "$ZSH/themes/$1.zsh-theme" ]]; then
  620. source "$ZSH/themes/$1.zsh-theme"
  621. else
  622. _omz::log error "%B$1%b theme not found"
  623. return 1
  624. fi
  625. # Update theme settings
  626. ZSH_THEME="$1"
  627. [[ $1 = random ]] || unset RANDOM_THEME
  628. }
  629. function _omz::update {
  630. local last_commit=$(cd "$ZSH"; git rev-parse HEAD)
  631. # Run update script
  632. if [[ "$1" != --unattended ]]; then
  633. ZSH="$ZSH" zsh -f "$ZSH/tools/upgrade.sh" --interactive || return $?
  634. else
  635. ZSH="$ZSH" zsh -f "$ZSH/tools/upgrade.sh" || return $?
  636. fi
  637. # Update last updated file
  638. zmodload zsh/datetime
  639. echo "LAST_EPOCH=$(( EPOCHSECONDS / 60 / 60 / 24 ))" >! "${ZSH_CACHE_DIR}/.zsh-update"
  640. # Remove update lock if it exists
  641. command rm -rf "$ZSH/log/update.lock"
  642. # Restart the zsh session if there were changes
  643. if [[ "$1" != --unattended && "$(cd "$ZSH"; git rev-parse HEAD)" != "$last_commit" ]]; then
  644. # Old zsh versions don't have ZSH_ARGZERO
  645. local zsh="${ZSH_ARGZERO:-${functrace[-1]%:*}}"
  646. # Check whether to run a login shell
  647. [[ "$zsh" = -* || -o login ]] && exec -l "${zsh#-}" || exec "$zsh"
  648. fi
  649. }
  650. function _omz::version {
  651. (
  652. cd "$ZSH"
  653. # Get the version name:
  654. # 1) try tag-like version
  655. # 2) try name-rev
  656. # 3) try branch name
  657. local version
  658. version=$(command git describe --tags HEAD 2>/dev/null) \
  659. || version=$(command git name-rev --no-undefined --name-only --exclude="remotes/*" HEAD 2>/dev/null) \
  660. || version=$(command git symbolic-ref --quiet --short HEAD 2>/dev/null)
  661. # Get short hash for the current HEAD
  662. local commit=$(command git rev-parse --short HEAD 2>/dev/null)
  663. # Show version and commit hash
  664. printf "%s (%s)\n" "$version" "$commit"
  665. )
  666. }